%% Get data
Home = cd; 

% Columns of the datasets
a.secid=1;
a.tr_date=2;
a.exp_date=3;
a.type=4;
a.str_price=5;
a.cal_days=6;
a.option_vol=7;
a.close=8;
a.moneyness=9;
a.mcap=10;

for iy=1996:2017

cd('C:\Users\Anastasios\Desktop\DISP');
S=strcat('data', int2str(iy),'_final_matlab.csv');
data=csvread(S,1,0);
cd(Home);


%% Data manipulation
% sas to matlab dates
data(:,a.tr_date:a.exp_date)=x2mdate(data(:,a.tr_date:a.exp_date)+21916); 

% delete ATM options
ATM=find(data(:,a.moneyness)>=0.95&data(:,a.moneyness)<=1.05);
data(ATM,:)=[];

% keep options with maturities between 5 and 60 calendar days
filt=find(data(:,a.cal_days)<=60&data(:,a.cal_days)>=5);
datam=data(filt,:);

[sx,sy]=size(datam);

%% DISP calculation for each company/date
% Finds the first and last rows for each company
i=diff(datam(:,a.secid));
j=find(i~=0);
jj=j+1;
v=vertcat(1,sx,j,jj);
v=sort(v); % this is the vector with the first and last rows for each company
lv=length(v);

W=[];
c=0;
while c+2<=lv
    cdata=datam(v(c+1):v(c+2),:); % all data in the year for each company
    [cx,cy]=size(cdata);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    id=diff(cdata(:,a.tr_date));
    jd=find(id~=0);
    jjd=jd+1;
    vd=vertcat(1,cx,jd,jjd);
    vd=sort(vd); % this is the vector with the first and last rows for each date
    lvd=length(vd);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    A=[];
    A=NaN(lvd/2,5);
    cdd=0;
    while cdd+2<=lvd
    tdata=cdata(vd(cdd+1):vd(cdd+2),:); % daily data for each company
    [tx,ty]=size(tdata);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    mdata=NaN(1,1);
    tlim=5; % I need at least 5 contracts traded per day
    if tx>=tlim
    ttrvol=sum(tdata(:,a.option_vol));
    weights=tdata(:,a.option_vol)./ttrvol;
    weightav=sum(weights.*tdata(:,a.moneyness));
    nomstd=sqrt(sum(weights.*((tdata(:,a.moneyness)-weightav).^2)));    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    mdata=nomstd;
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    A((cdd+2)/2,1)=tdata(1,a.secid);
    A((cdd+2)/2,2)=tdata(1,a.tr_date);
    A((cdd+2)/2,3)=tdata(1,a.close);
    A((cdd+2)/2,4)=tdata(1,a.mcap);
    A((cdd+2)/2,5)=mdata;
    cdd=cdd+2;
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    c=c+2;
    W=vertcat(W,A);
end
    W(:,a.tr_date)=m2xdate(W(:,a.tr_date));

    Az=strcat('daily_disp_', int2str(iy),'.mat');
    save (Az , 'W');
    clearvars -except a Home
end