%% Load data and remove last trading day of each month

% Columns of the datasets
a.secid=1;
a.tr_date=2;
a.close=3;
a.mcap=4;
a.disp=5;


DISP=[];
for iy=1996:2017 
S=strcat('daily_disp_', int2str(iy),'.mat');
load(S);
data=W; W=[];

data=sortrows(data,[a.tr_date,a.secid]); 
data(:,a.tr_date)=x2mdate(data(:,a.tr_date));

% Remove the last trading date of the month
ff=[];
LDayMonth = unique(eomdate(data(:,a.tr_date)));
for k=1:length(LDayMonth)
    D=LDayMonth(k)-data(:,a.tr_date);
    DD=D(D>=0);
    f=find(DD==min(DD));
    ff=vertcat(ff,f);
end

data(ff,:)=[];


%% Estimate monthly DISP
[sx, sy]=size(data);
dates=datevec(data(:,a.tr_date));
dates=dates(:,2);
i=diff(dates);
j=find(i~=0);
jj=j+1;
v=vertcat(1,sx,j,jj);
v=sort(v); % v gives the rows where each month begins and ends
lv=length(v);


Av=NaN(lv/2,2);
c=0;
while c+2<=lv
    tdata=data(v(c+1):v(c+2),:);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    [sxt, syt]=size(tdata);
    tdata=sortrows(tdata,[a.secid a.tr_date]); % monthly data for all companies
    k=diff(tdata(:,a.secid));
    u=find(k~=0);
    uu=u+1;
    vc=vertcat(1,sxt,u,uu);
    vc=sort(vc); % vc gives the rows where each company begins and ends
    lvc=length(vc);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    udate=unique(tdata(:,a.tr_date));
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    lc=0;
    Vcall=NaN(lvc/2,1);
    Mcw=NaN(lvc/2,1);
    while lc+2<=lvc
    cdata=tdata(vc(lc+1):vc(lc+2),:); % monthly data for each company
    if cdata(end,a.tr_date)==udate(end,1)&&sum(~isnan(cdata(:,a.disp)))>=10; % I need the firm to be traded at the end of the month and at least 10 obs 
    Vcall((lc+2)/2,:)=nanmean(cdata(:,a.disp));
    Mcw((lc+2)/2,:)=cdata(end,a.mcap);
    end
    lc=lc+2;
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Value-weighted (across stocks) monthly DISP
    zf=find(~isnan(Vcall));
    vweights=Mcw(zf,:)./sum(Mcw(zf,:));
    Vd=sum(vweights.*Vcall(zf,:));
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Av((c+2)/2,1)=m2xdate(udate(end,1));
    Av((c+2)/2,2)=Vd;
    c=c+2;   
end 

DISP=[DISP;Av];
clearvars -except a DISP
end

%% Save final time-series
xlswrite('DISP.xlsx',DISP);